﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
Sub Class_Globals
	
	Private dayClv As CustomListView
	Private mounthClv As CustomListView
	Private yearClv As CustomListView
	Private hourClv As CustomListView
	Private minutClv As CustomListView
	Private hebDateLb As Label
	Private mainLb As Label
	Private currentPanel As Panel
	Private mAct As Panel
	Dim xui As XUI
	Dim  minut , hour, day, mounth, year As String
	Private hourLb As Label
	Private dateLb As Label
	Private datePnl As Panel
	Private DThourPnl As Panel
	
	Private hidePnl As Panel
	Private yearScrollChangedIndex As Int
	Private mounthScrollChangedIndex As Int
	Private dayScrollChangedIndex As Int
	Private hourScrollChangedIndex As Int
	Private minuteScrollChangedIndex As Int
	Private t As Timer
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(act As Activity)
	t.Initialize("t",1000)
	t.Enabled=True
	InitializeP(act)
	SetTime
	
End Sub

Sub t_Tick
	Log("set")
End Sub

Sub InitializeP(act As Panel)
	act.RemoveAllViews
	Dim p As Panel
	p.Initialize("")
	act.AddView(p,0,0,act.Width,act.Height)
	
	p.LoadLayout("setdatetimely2")
	p.Enabled=True
	p.Visible=True
	p.BringToFront
	p.Color = Colors.ARGB(255,0,0,0)
	currentPanel=act
	mAct=act
	act.BringToFront
End Sub

Sub SetTime
	DateTime.DateFormat = "dd MM yyyy"
	Dim sd1() As String=Regex.Split(" ", $"$DateTime{DateTime.Now}"$)
	
	InitializeyearWv(sd1(2))

End Sub

Sub InitializeMinWv(s As String)
	Dim s As String=DateTime.GetMinute(DateTime.Now)
	minut=s
	Dim sPos As String
	For x=0 To 1
		For i =0 To 59
			Dim y As String=i
			Dim n As String
			If i < 10 Then
				n = "0" & i
			Else
				n = i
			End If
			CreateItem(n,minutClv)
			If y=s Then
				sPos=minutClv.Size-2
			End If
		Next
	Next	
	Sleep(100)
	minutClv.ScrollToItem(sPos)
	'Sleep(100)
	dateLb_Click
	hidePnl.Visible=False
	hidePnl.Enabled=False
End Sub

Sub InitializeHourWv(s As String)
	s=DateTime.GetHour(DateTime.Now)
	hour=s
	Dim sPos As String
	For x=0 To 1
		For i =0 To 23
			Dim y As String=i
			Dim n As String
			If i < 10 Then
				n = "0" & i
			Else
				n = i
			End If
			CreateItem(n,hourClv)
			If y=s Then
				sPos=hourClv.Size-2
			End If
		Next
	Next
	Sleep(100)
	hourClv.ScrollToItem(sPos)
	'Sleep(100)
	InitializeMinWv("")
End Sub


Sub InitializeDayWv(s As String)
	s=DateTime.GetDayOfMonth(DateTime.Now)
	day=s
	Dim sPos As String
	For x=0 To 1
		For i =1 To 31
			Dim y As String=i
			Dim n As String
			If i < 10 Then
				n = "0" & i
			Else
				n = i
			End If
			CreateItem(n,dayClv)
			If y=s Then
				sPos=dayClv.Size-2
			End If
		Next
	Next
	Sleep(100)
	dayClv.ScrollToItem(sPos)
	'Sleep(100)
	InitializeHourWv("")	
End Sub

Sub InitializeMounthWv(s As String)
	s=DateTime.GetMonth(DateTime.Now)
	mounth=s
	Dim sPos As String
	For x=0 To 1
		For i =1 To 12
			Dim y As String=i
			Dim n As String
			If i < 10 Then
				n = "0" & i
			Else
				n = i
			End If
			CreateItem(n,mounthClv)
			If y=s Then
				sPos=mounthClv.Size-2
			End If
		Next
	Next
	Sleep(100)
	mounthClv.ScrollToItem(sPos)
	'Sleep(100)
	InitializeDayWv("")
End Sub

Sub  InitializeyearWv(s As String)
	s=DateTime.GetYear(DateTime.Now)
	year=s
	Dim sPos As String
	For x=0 To 1
		For i =2019 To 2030
			Dim y As String=i
			CreateItem(y,yearClv)
			If y=s Then
				sPos=yearClv.Size-2
			End If
		Next
	Next
	Sleep(100)
	yearClv.ScrollToItem(sPos)
	'Sleep(100)
	InitializeMounthWv("")
End Sub

Sub CreateItem(n As String,clv As CustomListView)
	Dim p As B4XView=xui.CreatePanel("")
	Dim w As Int =clv.AsView.Width
	Dim h As Int =clv.AsView.Height/3
	p.SetLayoutAnimated(0,0,0,w,h)
	Dim l As Label
	l.Initialize("")
	l.Text=n
	l.TextColor=Colors.White
	l.TextSize=13
	l.Gravity=Gravity.CENTER
	p.AddView(l,0,0,p.Width,p.Height)
	clv.Add(p,l)	
End Sub

Sub Clv_ScrollChanged (Offset As Int,clv As CustomListView,s As String)
	Dim ii As Int=clv.FindIndexFromOffset(Offset)
	Dim v As Label=clv.GetValue(ii)
	
	If Offset<=0 Then
		clv.ScrollToItem(clv.Size/2-1)
	End If
	Dim i As Int = v.Height*(clv.Size-3)
	If Offset>=i Then
		clv.ScrollToItem(clv.Size/2-2)
	End If
	
	v.TextColor=Colors.White
	v.TextSize=13
	
	Dim v2 As Label=clv.GetValue(ii+2)
	v2.TextColor=Colors.White
	v2.TextSize=13
	Dim v1 As Label=clv.GetValue(ii+1)
	v1.TextColor=Colors.Cyan
	v1.TextSize=18
End Sub

Sub dayClv_ScrollChanged (Offset As Int)
	Clv_ScrollChanged (Offset,dayClv,"d")
	dayScrollChangedIndex = dayScrollChangedIndex + 1
	Dim MyIndex As Int = dayScrollChangedIndex 'ScrollChangedIndex is a global int variable.
	Sleep(300)
	If MyIndex = dayScrollChangedIndex Then
		Dim ii As Int=dayClv.FindIndexFromOffset(Offset)
		Dim v As Label=dayClv.GetValue(ii+1)
		day=v.Text
		dayClv.ScrollToItem(ii)
		dayScrollChangedIndex=0	
	End If
End Sub

Sub minutClv_ScrollChanged (Offset As Int)
	Clv_ScrollChanged (Offset,minutClv,"min")
	minuteScrollChangedIndex = minuteScrollChangedIndex + 1
	Dim MyIndex As Int = minuteScrollChangedIndex 'ScrollChangedIndex is a global int variable.
	Sleep(300)
	If MyIndex = minuteScrollChangedIndex Then
		Dim ii As Int=minutClv.FindIndexFromOffset(Offset)
		Dim v As Label=minutClv.GetValue(ii+1)
		minut=v.Text
		minutClv.ScrollToItem(ii)
		minuteScrollChangedIndex=0		
	End If
End Sub

Sub hourClv_ScrollChanged (Offset As Int)
	Clv_ScrollChanged (Offset,hourClv,"h")
	hourScrollChangedIndex = hourScrollChangedIndex + 1
	Dim MyIndex As Int = hourScrollChangedIndex 'ScrollChangedIndex is a global int variable.
	Sleep(300)
	If MyIndex = hourScrollChangedIndex Then
		Dim ii As Int=hourClv.FindIndexFromOffset(Offset)
		Dim v As Label=hourClv.GetValue(ii+1)
		hour=v.Text
		hourClv.ScrollToItem(ii)
		hourScrollChangedIndex=0
	End If
End Sub

Sub mounthClv_ScrollChanged (Offset As Int)
	Clv_ScrollChanged (Offset,mounthClv,"mn")
	mounthScrollChangedIndex = mounthScrollChangedIndex + 1
	Dim MyIndex As Int = mounthScrollChangedIndex 'ScrollChangedIndex is a global int variable.
	Sleep(300)
	If MyIndex = mounthScrollChangedIndex Then
		Dim ii As Int=mounthClv.FindIndexFromOffset(Offset)
		Dim v As Label=mounthClv.GetValue(ii+1)
		mounth=v.Text
		mounthClv.ScrollToItem(ii)
		mounthScrollChangedIndex=0	
	End If
End Sub

Sub yearClv_ScrollChanged (Offset As Int)
	Clv_ScrollChanged (Offset,yearClv,"y")
	yearScrollChangedIndex = yearScrollChangedIndex + 1
	Dim MyIndex As Int = yearScrollChangedIndex 'ScrollChangedIndex is a global int variable.
	Sleep(300)
	If MyIndex = yearScrollChangedIndex Then
		Dim ii As Int=yearClv.FindIndexFromOffset(Offset)
		Dim v As Label=yearClv.GetValue(ii+1)
		year=v.Text
		yearClv.ScrollToItem(ii)
		yearScrollChangedIndex=0		
	End If
End Sub

Sub dateLb_Click
	Private cdw As ColorDrawable
	cdw.Initialize2(Colors.White,0,1,HexToColor("#ff3EAA92"))
	dateLb.Background = cdw
	setCornerRadii(dateLb,0,0,45,45,45,45,0,0)
	Private cdw1 As ColorDrawable
	cdw1.Initialize2(Colors.ARGB(0,0,0,0),0,1,HexToColor("#ff3EAA92"))
	hourLb.Background=cdw1
	setCornerRadii(hourLb,45,45,0,0,0,0,45,45)
	datePnl.Visible=True
	datePnl.Enabled=True
	DThourPnl.Visible=False
	DThourPnl.Enabled=False
	hourLb.TextColor=Colors.White
	dateLb.TextColor=Colors.Black
End Sub

Sub hourLb_Click
	DThourPnl.Visible=True
	DThourPnl.Enabled=True
	DThourPnl.BringToFront
'	If  hoursfirstClick Then
''		InitializeHourWv(DateTime.GetHour(DateTime.Now))	
''		InitializeMinWv(DateTime.GetMinute(DateTime.Now))
'		hoursfirstClick=False
	'End If
	Private cdw As ColorDrawable
	cdw.Initialize2(Colors.White,0,1,HexToColor("#ff3EAA92"))
	hourLb.Background = cdw
	setCornerRadii(hourLb,45,45,0,0,0,0,45,45)
	Private cdw1 As ColorDrawable
	cdw1.Initialize2(Colors.ARGB(0,0,0,0),0,1,HexToColor("#ff3EAA92"))
	dateLb.Background=cdw1
	setCornerRadii(dateLb,0,0,25,25,25,25,0,0)
	hourLb.TextColor=Colors.Black
	dateLb.TextColor=Colors.White
	datePnl.Visible=False
	datePnl.Enabled=False
	datePnl.SendToBack
End Sub

Sub exitDateTime_Click
	Hide
End Sub

Sub Hide
	CallSub(Main,"LoadHomeScreen")
End Sub

Sub setDateTimeOKBtn_Click
'	SetTimesStrings
	Dim newDate As Long
	Dim tickPerMin As Int=60000
	Dim tickPrHout As Long = 60*tickPerMin
	Try
		DateTime.DateFormat = "dd/MM/yyyy"
		'Dim timestr As String = dayLb.Text & "/" & mounthLb.Text & "/" & yearLb.Text &   " "  & hourLb.Text & ":" & minLb.Text & ":" & DateTime.GetSecond(DateTime.Now)
		Dim timestr As String =day  & "/" & mounth  & "/" & year
		Dim t1 As Long = (hour*tickPrHout) +( minut*tickPerMin) + (1000 * DateTime.GetSecond(DateTime.Now))
		newDate = DateTime.DateParse(timestr)+t1
		Dim d As Long=DateTime.Now
		Dim timeDif As Long=d-newDate		
		File.WriteString(File.DirInternal,"ClockDif",timeDif)
		Hide
	Catch
		Msgbox("בבקשה לבחור תאריך חוקי","תאריך שגוי")
	End Try
End Sub

Sub SetTimesStrings
	Dim i As Int=mounth
	If i<10 Then
		mounth="0" & mounth
	End If
	i=day
	If i<10 Then
		day="0" & day
	End If
End Sub
Sub setCornerRadii(v As View, Rx_TopLeft As Float, Ry_TopLeft As Float, Rx_TopRight As Float, Ry_TopRight As Float, Rx_BottomRight As Float, Ry_BottomRight As Float, Rx_BottomLeft As Float, Ry_BottomLeft As Float)
	Dim jo As JavaObject = v.Background
	If v.Background Is ColorDrawable Or v.Background Is GradientDrawable Then
		jo.RunMethod("setCornerRadii", Array As Object(Array As Float(Rx_TopLeft, Ry_TopLeft, Rx_TopRight, Ry_TopRight, Rx_BottomRight, Ry_BottomRight, Rx_BottomLeft, Ry_BottomLeft)))
	End If
End Sub

Private Sub HexToColor(Hex As String) As Int
	Dim bc As ByteConverter
	If Hex.StartsWith("#") Then
		Hex = Hex.SubString(1)
	Else If Hex.StartsWith("0x") Then
		Hex = Hex.SubString(2)
	End If
	Dim ints() As Int = bc.IntsFromBytes(bc.HexToBytes(Hex))
	Return ints(0)
End Sub

Sub autoShabatModeSw_ValueChanged (Value As Boolean)
	'Starter.ShabothH.EntrShabatAutomatically(Value)
End Sub
